class Thermostat
  attr_reader :cooling, :heating

  def initialize(args)
    @current_value = args.fetch(:current_temperature, 20)
    @wanted_value = args.fetch(:wanted_temperature, 20)
    @range = args.fetch(:range, 1) / 2
  end

  def heat
    @heating = true
    @cooling = false
  end

  def cool
    @heating = false
    @cooling = true
  end

  def all_off
    @heating = false
    @cooling = false
  end

  def temp(new_temperature)
    @current_value = new_temperature
  end

  def update
    if @current_value < @wanted_value - @range
      heat
    elsif @current_value > @wanted_value + @range
      cool
    else
      all_off
    end
  end
end
